--- old/usr/src/lib/libipadm/common/libipadm.h	Sat Jul  5 09:39:29 2014
+++ new/usr/src/lib/libipadm/common/libipadm.h	Sat Jul  5 09:39:29 2014
@@ -20,6 +20,7 @@
  */
 /*
  * Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright 2013 Nexenta Systems, Inc. All rights reserved.
  */
 #ifndef _LIBIPADM_H
 #define	_LIBIPADM_H
@@ -36,6 +37,8 @@
 #include <libnvpair.h>
 #include <netinet/tcp.h>
 #include <sys/stropts.h>
+#include <sys/list.h>
+#include <stddef.h>
 
 #define	IPADM_AOBJ_USTRSIZ	32
 #define	IPADM_AOBJSIZ		(LIFNAMSIZ + IPADM_AOBJ_USTRSIZ)
@@ -191,12 +194,29 @@
 	IFIS_DISABLED		/* Interface has been disabled. */
 } ipadm_if_state_t;
 
+typedef list_t ipadm_ipmp_members_t;
+
+typedef struct {
+    list_node_t node;
+    char if_name[LIFNAMSIZ];
+} ipadm_ipmp_member_t;
+
+typedef enum {
+    IPADM_IF_CLASS_REGULAR,
+    IPADM_IF_CLASS_IPMP,
+    IPADM_IF_CLASS_VIRTUAL,
+    IPADM_IF_CLASS_UNKNOWN
+} ipadm_if_class_t;
+
 typedef struct ipadm_if_info_s {
 	struct ipadm_if_info_s	*ifi_next;
 	char			ifi_name[LIFNAMSIZ];	/* interface name */
+	ipadm_if_class_t ifi_class; /* interface class */
 	ipadm_if_state_t	ifi_state;		/* see above */
 	uint_t			ifi_cflags;		/* current flags */
 	uint_t			ifi_pflags;		/* persistent flags */
+	ipadm_ipmp_members_t    ifi_ipmp_cmembers; /* current IPMP group members */
+	ipadm_ipmp_members_t    ifi_ipmp_pmembers; /* persistent IPMP grp members */
 } ipadm_if_info_t;
 
 /* ipadm_if_info_t flags */
@@ -270,6 +290,10 @@
 extern ipadm_status_t	ipadm_delete_if(ipadm_handle_t, const char *,
 			    sa_family_t, uint32_t);
 extern void		ipadm_if_move(ipadm_handle_t, const char *);
+extern ipadm_status_t ipadm_add_ipmp_member(ipadm_handle_t, const char *,
+	    const char *, uint32_t);
+extern ipadm_status_t ipadm_remove_ipmp_member(ipadm_handle_t, const char *,
+	    const char *, uint32_t);
 
 /*
  * Address management functions
